% Jacobians for feedforward neural network.  Single output
% E. Wan

function [dW1,dB1,dW2,dB2,dX] = jacobXW(W1,B1,W2,B2,X);

% forward pass

HidOut = tanh(W1*X + B1);
OUT = W2*HidOut + B2;


% Backprop 

deltaHid = W2' .* (1 - (HidOut.*HidOut));


% X - Jacobian

dX = deltaHid' * W1;


% W - Jacobian


dB2 = 1;
dB1 = deltaHid;

dW2 = HidOut';

[numH,numT] = size(W1);

dW1 = zeros(numH,numT);
for h = (1:numH)
 dW1(h,:) = deltaHid(h) .* X';
end



